GHSA-3mwq-h3g6-ffhm

Source
https://github.com/advisories/GHSA-3mwq-h3g6-ffhm
Import Source
https://github.com/github/advisory-database/blob/main/advisories/github-reviewed/2023/10/GHSA-3mwq-h3g6-ffhm/GHSA-3mwq-h3g6-ffhm.json
Aliases
Published
2023-10-05T20:55:58Z
Modified
2024-02-09T00:31:39Z
Details

Vapor incorrectly handles errors encountered during parsing of HTTP 1.x requests, triggering a precondition failure in swift-nio due to API misuse and causing immediate termination of the server process.

Impact

This is a denial of service vulnerability, impacting all users of affected versions of Vapor. Because the crash is an explicit assertion failure, there is no corruption of process state and no risk of data leakage or unauthorized code execution. Total impact is limited to an immediately recoverable service interruption.

Patches

The issue is fixed as of Vapor release 4.84.2.

Workarounds

None known at this time.

For more information

If you have any questions or comments about this advisory: * Open an issue in the Vapor repo * Ask in Vapor Discord

Acknowledgements

Full credit for reporting this issue goes to @t0rchwo0d, with additional thanks for responsibly disclosing.

References

Affected packages

SwiftURL / github.com/vapor/vapor

Package

Name
github.com/vapor/vapor

Affected ranges

Type
SEMVER
Events
Introduced
4.83.2
Fixed
4.84.2